# To change this template, choose Tools | Templates
# and open the template in the editor.

class CompundingPdf < Prawn::Document
  def initialize(report,loc,shipto,compDetail,cstype,uRl,isProforma,isTakeTax,gprams,isrndamt)
    super(:margin_top=>20,:page_size => [700, 700],:page_layout => :landscape)
    @invoice    = report
    @loc        = loc
    @shipto     = shipto
    @compDetail = compDetail
    @cstype     = cstype
    @uRl2       = uRl
    @uRl        = Rails.root.join "public"
    @logoSize   = 0.5   
    @isProforma = isProforma
    @isTakeTax  = isTakeTax
    @gprams     = gprams
    @isrndamt   = isrndamt
    @username   = @gprams[:autherizedUserName]
  
    line_items
 end

def count_mcell
  @count_cell ||= 0
  @count_cell = @count_cell+1
end

 def line_items
        move_down 2
         pad(-1) {
           if @compDetail.cmp_show_logo =='Y'
            if @compDetail.cmp_logos.to_s.length >1
               @filesExt = Rails.root.join "public", "images", "logo","thumb",@compDetail.cmp_logos.to_s
               if File.exist?(@filesExt)
                image open(@uRl+"images/logo/thumb/"+@compDetail.cmp_logos.to_s),:scale => @logoSize,:position => :right,:vposition => :top
               else
                 pad(10) { text "" }
               end
            end
          else
           pad(10) { text "" }
          end
          }
          # header
         
          bounding_box [bounds.left, bounds.top], :width  => bounds.width do
          font "Helvetica"
          
          text "<b>COMPOUNDING DETAILS</b>", :align => :center, :size =>10,:inline_format=> TRUE
          move_down 10
          if @compDetail.cmp_companyname.to_s!=nil && @compDetail.cmp_companyname.to_s!=''
          text "<b>"+@compDetail.cmp_companyname.to_s+"</b>", :align => :left, :size => 10,:vposition => :top,:inline_format=> TRUE
          end
          if @compDetail.cmp_addressline1.to_s!=nil && @compDetail.cmp_addressline1.to_s!=''
          text ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? @compDetail.cmp_addressline1.to_s: '' )+((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline1.to_s.length.to_i >1) ? ' ': '' )+@compDetail.cmp_addressline2.to_s : '')+((@compDetail.cmp_addressline3.to_s.length.to_i >1) ? ((@compDetail.cmp_addressline2.to_s.length.to_i >1) ? ' ': '' )+"\n"+@compDetail.cmp_addressline3.to_s: ''), :align => :left, :size => 9,:vposition => :top
          end
          if @compDetail.cmp_telephonenumber.to_s!=nil && @compDetail.cmp_telephonenumber.to_s!=''
          text @compDetail.cmp_telephonenumber.to_s+((@compDetail.cmp_telephonenumber.to_s.length.to_i >1) ? ', +91 ': '')+@compDetail.cmp_cell_number.to_s, :align => :left, :size =>9,:vposition => :top
          end
          stroke_horizontal_rule
          move_down 10
          text "Compounding For : "+@invoice[0].prodname.to_s, :align => :left, :size => 10,:vposition => :top,:inline_format=> TRUE
        
       end

    move_down 10
    
    table line_item_rows, :cell_style => {:inline_format => true }, :width=>630 do
      row(0).column(1..14).align = :center
      row(0).column(1).width=100
      row(0).column(2).width=45
      row(0).column(3).width=50
      row(0).column(4).width=60
      row(0).column(5).width=50
      row(0).column(6).width=60
      row(0).column(7).width=50      
      row(1..5000).column(4).align = :right
      cells.size = 7
      cells.padding = 5
      cells.min_width = 300
      cells.border_width = 1
      self.row_colors =["FFFFFF"]
      self.header =true
    end
    move_down 60
    #text "Created By :"+@username.to_s, :align => :left, :size => 10,:vposition => :top,:inline_format=> TRUE
    #text "Authorized Signatory ", :align => :right, :size => 10,:vposition => :top,:inline_format=> TRUE
 end

 def line_item_rows
     [["SL.No.","MatCode","MatDescription","UOM","Actual QTY %","Remarks"]]+
    @invoice.each.map do |inv|
     [count,(inv.cpd_itemcode.to_s!=nil ? inv.cpd_itemcode.to_s : ''),inv.cpd_itemname.to_s,(inv.cpd_uom.to_s!='' ? inv.cpd_uom.to_s : ''),(inv.cpd_qty.to_i >0 ? inv.cpd_qty.to_s : ''),inv.cpd_remarks.to_s]
    end
end

def count
  @count ||= 0
  @count = @count+1
end
def make_sum_of_all
    @tqnty    = 0
    @tstok    = 0
    @tact     = 0
   
    @invoice.each do |ts|
        @tqnty    = @tqnty+ts.rqd_requisition_qty.to_i
        @tstok    = @tstok+ts.rqd_stock_qty.to_i
        @tact     = @tact+ts.rqd_actual_qty.to_i
        
   end
 end
 def number_currency_in_words
   NumbersInWords.in_words(@tnetamt.to_f).split(/ |\_|\-/).map(&:capitalize).join(" ")
 end
def date_formats(dates)
  ndate = ''
  if dates.to_s!=nil && dates.to_s!=''
    nrdate = Date.parse(dates.to_s)
    ndate  = nrdate.strftime('%d-%b-%Y')
  end
  return ndate
end
end
